const hue_gray = 230;
const hue_brown = 25;
const hue_brown_shade = 10;
const hue_orange = 37;
const hue_purple = 250;
const hue_pink = 310;
const hue_red = 340;
const hue_red_shade = 335;
const hue_redbrown_dark = 0;
const hue_yellow = 57;
const hue_green = 140;
const hue_green_shade = 145;
const hue_sky = 203;
const hue_blue = 240;
const hue_blue_shade = 235;
const hue_blue_shade_2 = 240;
const hue_bluegreen_dark = 215;

const saturation_max = 90;
const saturation_normal = 60;
const saturation_low = 40;
const saturation_min = 13;

const lightness_max = 95;
const lightness_light = 67;
const lightness_mediumlight = 62;
const lightness_medium = 50;
const lightness_mediumdark = 40;
const lightness_dark = 30;
const lightness_almostverydark = 25;
const lightness_verydark = 20;
const lightness_min = 5;

const hsl = (h, s, l) => [h, s, l];

const palette = [
	hsl(hue_gray, saturation_min, lightness_max),
	hsl(hue_gray, saturation_min, lightness_light),
	hsl(hue_gray, saturation_min, lightness_dark),
	hsl(hue_gray, saturation_min, lightness_min),
	hsl(hue_orange, saturation_normal, lightness_medium),
	hsl(hue_brown, saturation_low, lightness_light),
	hsl(hue_brown_shade, saturation_low, lightness_mediumdark),
	hsl(hue_pink, saturation_normal, lightness_light),
	hsl(hue_red, saturation_normal, lightness_medium),
	hsl(hue_red_shade, saturation_normal, lightness_dark),
	hsl(hue_yellow, saturation_max, lightness_mediumlight),
	hsl(hue_green, saturation_normal, lightness_medium),
	hsl(hue_green_shade, saturation_normal, lightness_dark),
	hsl(hue_sky, saturation_max, lightness_light),
	hsl(hue_blue, saturation_normal, lightness_mediumlight),
	hsl(hue_blue_shade, saturation_normal, lightness_mediumdark),
	hsl(hue_bluegreen_dark, saturation_normal, lightness_verydark),
]